# coding: utf-8

"""
    Bandwidth

    Bandwidth's Communication APIs

    The version of the OpenAPI document: 1.0.0
    Contact: letstalk@bandwidth.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, Dict
from pydantic import BaseModel, Field, StrictStr
from bandwidth.models.inbound_message_callback_message import InboundMessageCallbackMessage

class InboundMessageCallback(BaseModel):
    """
    Inbound Message Callback
    """
    time: datetime = Field(...)
    type: StrictStr = Field(...)
    to: StrictStr = Field(...)
    description: StrictStr = Field(...)
    message: InboundMessageCallbackMessage = Field(...)
    additional_properties: Dict[str, Any] = {}
    __properties = ["time", "type", "to", "description", "message"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> InboundMessageCallback:
        """Create an instance of InboundMessageCallback from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of message
        if self.message:
            _dict['message'] = self.message.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> InboundMessageCallback:
        """Create an instance of InboundMessageCallback from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return InboundMessageCallback.parse_obj(obj)

        _obj = InboundMessageCallback.parse_obj({
            "time": obj.get("time"),
            "type": obj.get("type"),
            "to": obj.get("to"),
            "description": obj.get("description"),
            "message": InboundMessageCallbackMessage.from_dict(obj.get("message")) if obj.get("message") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


