# coding: utf-8

"""
    Bandwidth

    Bandwidth's Communication APIs

    The version of the OpenAPI document: 1.0.0
    Contact: letstalk@bandwidth.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictStr

class PageInfo(BaseModel):
    """
    PageInfo
    """
    prev_page: Optional[StrictStr] = Field(None, alias="prevPage", description="The link to the previous page for pagination.")
    next_page: Optional[StrictStr] = Field(None, alias="nextPage", description="The link to the next page for pagination.")
    prev_page_token: Optional[StrictStr] = Field(None, alias="prevPageToken", description="The isolated pagination token for the previous page.")
    next_page_token: Optional[StrictStr] = Field(None, alias="nextPageToken", description="The isolated pagination token for the next page.")
    additional_properties: Dict[str, Any] = {}
    __properties = ["prevPage", "nextPage", "prevPageToken", "nextPageToken"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PageInfo:
        """Create an instance of PageInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PageInfo:
        """Create an instance of PageInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PageInfo.parse_obj(obj)

        _obj = PageInfo.parse_obj({
            "prev_page": obj.get("prevPage"),
            "next_page": obj.get("nextPage"),
            "prev_page_token": obj.get("prevPageToken"),
            "next_page_token": obj.get("nextPageToken")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


