# coding: utf-8

"""
    Bandwidth

    Bandwidth's Communication APIs

    The version of the OpenAPI document: 1.0.0
    Contact: letstalk@bandwidth.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class Transcription(BaseModel):
    """
    Transcription
    """
    text: Optional[StrictStr] = Field(None, description="The transcribed text")
    confidence: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The confidence on the recognized content, ranging from `0.0` to `1.0` with `1.0` being the highest confidence.")
    additional_properties: Dict[str, Any] = {}
    __properties = ["text", "confidence"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Transcription:
        """Create an instance of Transcription from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Transcription:
        """Create an instance of Transcription from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Transcription.parse_obj(obj)

        _obj = Transcription.parse_obj({
            "text": obj.get("text"),
            "confidence": obj.get("confidence")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


