# coding: utf-8

"""
    Bandwidth

    Bandwidth's Communication APIs

    The version of the OpenAPI document: 1.0.0
    Contact: letstalk@bandwidth.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictStr

class TranscriptionMetadata(BaseModel):
    """
    If the recording was transcribed, metadata about the transcription
    """
    id: Optional[StrictStr] = Field(None, description="The unique transcription ID")
    status: Optional[StrictStr] = Field(None, description="The current status of the process. For recording, current possible values are 'processing', 'partial', 'complete', 'deleted', and 'error'. For transcriptions, current possible values are 'none', 'processing', 'available', 'error', 'timeout', 'file-size-too-big', and 'file-size-too-small'. Additional states may be added in the future, so your application must be tolerant of unknown values.")
    completed_time: Optional[StrictStr] = Field(None, alias="completedTime", description="The time that the transcription was completed")
    url: Optional[StrictStr] = Field(None, description="The URL of the [transcription](#operation/getCallTranscription)")
    additional_properties: Dict[str, Any] = {}
    __properties = ["id", "status", "completedTime", "url"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TranscriptionMetadata:
        """Create an instance of TranscriptionMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "additional_properties"
                          },
                          exclude_none=True)
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TranscriptionMetadata:
        """Create an instance of TranscriptionMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TranscriptionMetadata.parse_obj(obj)

        _obj = TranscriptionMetadata.parse_obj({
            "id": obj.get("id"),
            "status": obj.get("status"),
            "completed_time": obj.get("completedTime"),
            "url": obj.get("url")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


